package objekteimnamensraumaufloesen;

//  1. importieren der bentighten Packages und Klassen
import java.util.Properties;
import org.omg.CORBA.*;
import org.omg.CosNaming.*;

/**
 * Title:        Objekt Referenzen auflsen
 * Description:  Lesen einer Objektreferenz in einem
 * Namensraum
 * Copyright:    Copyright (c) J.M.Joller
 * Company:      Joller-Voss
 * @author J.M.Joller
 * @version 1.0
 */

public class Client {

   public static void main(String args[])
    {
      try {
        // 2. Port und Host setzen
        Properties props = new Properties();
        props.put("org.omg.CORBA.ORBInitialPort", "1050");
        props.put("org.omg.CORBA.ORBInitialHost", "localhost");
        // ORB instanzieren
        ORB orb = ORB.init(args, props);

        // 3. Initialer Namenskontext
        //    ctx zuordnen

        NamingContextExt nc =
          NamingContextExtHelper.narrow(orb.resolve_initial_references(
            "NameService"));

        // 4. Auflsen der einzelnen Namensrume
        org.omg.CORBA.Object sched = nc.resolve_str("Personal/schedule");
        org.omg.CORBA.Object cal = nc.resolve_str("Personal/calendar");
        org.omg.CORBA.Object plan = nc.resolve_str("plans");

	if (sched == null){
	  System.out.println("Schedule ist null");
	} else System.out.println("Schedule Objektreferenz wurde gefunden");

	if (cal == null){
	  System.out.println("Calendar ist null");
	} else System.out.println("Calendar Objektreferenz wurde gefunden");

	if (plan == null){
	  System.out.println("Plans ist null");
	} else System.out.println("Plans Objektreferenz wurde gefunden");

      } catch (Exception e) {
        e.printStackTrace(System.err);
      }
    }
}