package poaerstesbeispiel;

/**
 * Title:        CORBA - Portable Object Adapter Vererbungsmodell
 * Description:
 * Copyright:    Copyright (c) J.M.Joller
 * Company:      Joller-Voss
 * @author J.M.Joller
 * @version 1.0
 */

import HalloApp.*;
import org.omg.CosNaming.*;
import org.omg.CosNaming.NamingContextPackage.*;
import org.omg.CORBA.*;

public class Client
{
  static Hallo halloImpl;

  public static void main(String args[])
    {
      try{
        // kreiere und initialisiere den ORB
        System.out.println("[POA-Client.main()]Kreiere und initialisiere den ORB");
	ORB orb = ORB.init(args, null);

        // bestimme den root naming context
        System.out.println("[POA-Client.main()]bestimme den root naming context");
        org.omg.CORBA.Object objRef =
	    orb.resolve_initial_references("NameService");
        // Benutze den NamingContextExt anstelle von NamingContext.
        // Dies ist Teil des Interoperable Naming Service.
        System.out.println("[POA-Client.main()]Benutze den NamingContextExt");
        NamingContextExt ncRef = NamingContextExtHelper.narrow(objRef);

        // Auflsen der Objekt Referez im Namensraum / Naming
        System.out.println("[POA-Client.main()]Aufloesen der Objekt Referez im Namensraum");
        String name = "POA Grsse";
        halloImpl = HalloHelper.narrow(ncRef.resolve_str(name));
        System.out.println("[POA-Client.main()]Bestimmen einer Referenz auf das Server Objekt\n");
        System.out.println(halloImpl+"\n\n");
        System.out.println("[POA-Client.main()]Aufruf der Servant Methode 'wieGehts()'");
        System.out.println("[POA-Client.main()]Antwort des Servants : "+halloImpl.wieGehts());
        halloImpl.shutdown();

	} catch (Exception e) {
          System.out.println("[POA-Client.main()]Fehler " + e) ;
	  e.printStackTrace(System.out);
	  }
    }

}
