package poaimplbase;

import ImplBaseModell.*;
import org.omg.CosNaming.*;
import org.omg.CosNaming.NamingContextPackage.*;
import org.omg.CORBA.*;


/**
 * Title:        Verebungbasiertes CORBA Modell
 * Description:  ImplBase basiertes CORBA Beispiel
 * Copyright:    Copyright (c) J.M.Joller
 * Company:      Joller-Voss
 * @author J.M.Joller
 * @version 1.0
 */

public class ImplBaseClient {
  static Hallo implBaseHallo;

  public static void main(String args[]){
      System.out.println("[ImplBaseClient]Start");

    try{
      // kreiere und initialisiere den ORB
      System.out.println("[ImplBaseClient]ORB.init()");
      ORB orb = ORB.init(args, null);

      // bestimme den root naming context
      System.out.println("[ImplBaseClient]Namingkontext Root bestimmen");
      org.omg.CORBA.Object objRef =
	  orb.resolve_initial_references("NameService");
      NamingContext ncRef = NamingContextHelper.narrow(objRef);

      // bestimmen der Objekt Referenz im Namensraum
      System.out.println("[ImplBaseClient]suchen des Servants");
      String name = "ImplBaseVariante";
      NameComponent nc = new NameComponent(name,"");
      NameComponent path[] = {nc};

      Hallo implBaseHallo = HalloHelper.narrow(ncRef.resolve(path));

      System.out.println("[ImplBaseClient]Bestimme Referenz auf den Servant: " + implBaseHallo+"\n");
      System.out.println(implBaseHallo.wieGehts());
      System.out.println("[ImplBaseClient]Server shutdown()");
      implBaseHallo.shutdown();
      }

    catch (Exception e) {
      System.out.println("ERROR : " + e) ;
      e.printStackTrace(System.out);
    }
  }
}

