package poaimplbase;

import ImplBaseModell.*;
import org.omg.CosNaming.*;
import org.omg.CosNaming.NamingContextPackage.*;
import org.omg.CORBA.*;
import org.omg.PortableServer.*;
import org.omg.PortableServer.POA;

import java.util.Properties;

/**
 * Title:        Verebungbasiertes CORBA Modell
 * Description:  ImplBase basiertes CORBA Beispiel
 * Copyright:    Copyright (c) J.M.Joller
 * Company:      Joller-Voss
 * @author J.M.Joller
 * @version 1.0
 */

public class ImplBaseServer{

  public static void main(String args[]){
    System.out.println("[ImplBaseServer]Start");
    try{
      // kreieren und initialisieren des ORBs
      System.out.println("[ImplBaseServer]ORB.init()");
      ORB orb = ORB.init(args, null);

      // kreieren des Servants
      System.out.println("[ImplBaseServer]Servant kreieren");
      ImplBaseServant implBaseHallo = new ImplBaseServant();
      implBaseHallo.setORB(orb);

      // bestimme root naming context
      System.out.println("[ImplBaseServer]Namenskontext");
      org.omg.CORBA.Object objRef = orb.resolve_initial_references("NameService");
      NamingContext ncRef = NamingContextHelper.narrow(objRef);

      Hallo href = HalloHelper.narrow(implBaseHallo);

      // binden der Objekt Referenz im Namensraum
      System.out.println("[ImplBaseServer]binden des Servants");
      String name = "ImplBaseVariante";
      NameComponent nc = new NameComponent(name,"");
      NameComponent path[] = {nc};
      ncRef.rebind(path, href);

      System.out.println("[ImplBaseServer]Der Server ist bereit und wartet auf Anfragen ...");

      // warten auf Client Anfragen
      orb.run();
      }

    catch (Exception e){
      System.err.println("ERROR: " + e);
      e.printStackTrace(System.out);
    }

    System.out.println("[ImplBaseServer]Der Server wird heruntergefahren ...");

  }
}

