//package persistenz;

import org.omg.CORBA.ORB;

/**
 * Title:        Serverseitige Persistenz in CORBA mit POA
 * Description:  Einfaches Beispiel fr den Einsatz des POA unter Bercksichtigung der Persistenz des Servers und des Namensdienstes
 * Copyright:    Copyright (c) J.M.Joller
 * Company:      Joller-Voss
 * @author J.M.Joller
 * @version 1.0
 */

public class PersistenterServant extends Persistent.HalloPOA {
    private ORB orb;

    public PersistenterServant( ORB orb ) {
        this.orb = orb;
        //System.out.println("[PersistenterServant]Konstruktor(orb)");
    }

    /**
     *  wieGehts() Methode implementiert eine einfache Antwort auf eine Anfrage
     */
    public String wieGehts( ) {
        System.out.println("[PersistenterServant]wieGehts()");
        return "Mir geht's gut! Wie geht's Dir?...";
    }

    /**
     *  shutdown() Methode zum Herunterfahern des ORBs
     */
    public void shutdown( ) {
        System.out.println("[PersistenterServant]shutdown()");
        orb.shutdown( false );
    }
}
