package poatie;

import POATieModell.*;
import org.omg.CosNaming.*;
import org.omg.CosNaming.NamingContextPackage.*;
import org.omg.CORBA.*;


/**
 * Title:        POA Tie Modell
 * Description:  Delegationsmodell, mit Package Angaben
 * Copyright:    Copyright (c) J.M.Joller
 * Company:      Joller-Voss
 * @author J.M.Joller
 * @version 1.0
 */

public class DelegationsClient{

  public static void main(String args[]){
      System.out.println("[DelegationsClient]Start");

    try{
      // kreiere und initialisiere den ORB
      System.out.println("[DelegationsClient]ORB.init()");
      ORB orb = ORB.init(args, null);

      // bestimme den root naming context
      System.out.println("[DelegationsClient]Namingkontext Root bestimmen");
      org.omg.CORBA.Object objRef =
	  orb.resolve_initial_references("NameService");

      // verwende NamingContextExt statt NamingContext.
      // Dieser ist Teil des Interoperable Naming Service.
      NamingContextExt ncRef = NamingContextExtHelper.narrow(objRef);

      // auflsen der Objekt Referenz im Namensraum
      System.out.println("[DelegationsClient]Servant suchen");
      String name = "DelegationsVariante";
      Hallo delegationsHalloImpl = HalloHelper.narrow(ncRef.resolve_str(name));

      System.out.println("[DelegatiosnClient]Bestimme Referenz auf den Servant: " + delegationsHalloImpl);
      System.out.println(delegationsHalloImpl.wieGehts());
      System.out.println("[DelegationsClient]Server shutdown()");
      delegationsHalloImpl.shutdown();
      }

    catch (Exception e) {
      System.out.println("ERROR : " + e) ;
      e.printStackTrace(System.out);
    }
  }
}

