package rmioveriiopohnepoa;

import java.rmi.RemoteException;
import java.net.MalformedURLException;
import java.rmi.NotBoundException;
import javax.rmi.*;
import java.util.Vector;
import javax.naming.NamingException;
import javax.naming.InitialContext;
import javax.naming.Context;

/**
 * Title:        RMI over IIOP
 * Description:  einfaches Beispiel fr den Einsatz von RMI over IIOP im JDK1.4
 * Copyright:    Copyright (c) J.M.Joller
 * Company:      Joller-Voss
 * @author J.M.Joller
 * @version 1.0
 */

public class Client {
    public static void  main( String args[] ) {
        Context ic;
        Object objRef;
        Interface iFace;
        System.out.println("[Client]Start");
        try {
            ic = new InitialContext();

        // 1: Bestimmen der Objektreferenz im Namensraum
        // (JNDI call).
            System.out.print("[Client]Bestimmen der Objektreferenz");
            System.out.print("        im Namensraum / Naming Service\n");
            objRef = ic.lookup("RemoteService");

        // 2: Umwandeln der Objektreferenz (narrow())
        // und Methodenaufruf.
            System.out.print("[Client]Umwandeln der Objektreferenz");
            System.out.print("        in ein Interface Objekt\n");
            iFace = (Interface)PortableRemoteObject.narrow(
                objRef, Interface.class);
            System.out.println("[Client]Aufruf der remote Methode : Wie geht's Dir?");
            System.out.println(iFace.wieGehts( "Wie geht's Dir? " ));

        } catch( Exception e ) {
            System.err.println( "[Client]Exception " + e + "Caught" );
            e.printStackTrace( );
            return;
        }
    }
}
