package rmioveriiopohnepoa;

import javax.naming.InitialContext;
import javax.naming.Context;

/**
 * Title:        RMI over IIOP
 * Description:  einfaches Beispiel fr den Einsatz von RMI over IIOP im JDK1.4
 * Copyright:    Copyright (c) J.M.Joller
 * Company:      Joller-Voss
 * @author J.M.Joller
 * @version 1.0
 */

public class Server {
    public static void main(String[] args) {
        try {
            System.out.println("[Server]Start");
            // 1: Instanzieren des Servants
            System.out.println("[Server]Instanzieren des Servants");
            Servant remoteRef = new Servant();

            // 2) Eintragen in den Namensdienst
            // (JNDI API)
            Context initialNamingContext = new InitialContext();
            System.out.println("[Server]Eintrag in den Namensraum");
            initialNamingContext.rebind("RemoteService", remoteRef );

            System.out.print("[Server]Der Server ist bereit ");
            System.out.print("und wartet auf Anfragen...\n");

         } catch (Exception e) {
            System.out.println("[Server]Exception: " + e);
            e.printStackTrace();
         }
     }
}