package rmooveriiopmitpoa;

import java.rmi.RemoteException;
import java.net.MalformedURLException;
import java.rmi.NotBoundException;
import javax.rmi.*;
import java.util.Vector;
import javax.naming.NamingException;
import javax.naming.InitialContext;
import javax.naming.Context;

/**
 * Title:        RMI over IIOP
 * Description:  RMI over IIOP mit POA
 * Copyright:    Copyright (c) J.M.Joller
 * Company:      Joller-Voss
 * @author J.M.Joller
 * @version 1.0
 */

public class Client {
  public static void  main( String args[] ) {
    Context ic=null;
    Object objRef=null;
    Interface hi;
    System.out.println("[Client]Start");

    try {
      System.out.println("[Client]Naming Context - Instanzieren");
      ic = new InitialContext();
    } catch (NamingException e) {
      System.out.println("[Client]Naming Context - Instanzieren schlug fehl" + e);
      e.printStackTrace();
      System.exit(2);
    }

    // 1) Objektreferenz fr den Namensdienst
    //    (JNDI)
    try {
      System.out.println("[Client]Naming Context - Lookup des POAServers");
      objRef = ic.lookup("POAServer");
    } catch (NamingException e) {
      System.out.println("[Client]Naming Context - Lookup des POAServers schlug fehl "+e);
      e.printStackTrace();
      System.exit(4);
    }

    // 2) Narrow der Objektreferenz auf den gewnschten Datentyp
    try {
      hi = (Interface) PortableRemoteObject.narrow(
        objRef, Interface.class);
      System.out.println("[Client]Aufruf der remote Methode - "+
                                    hi.wieGehts("Wie geht's?") );
    } catch (ClassCastException e) {
      System.out.println("[Client]Aufruf der remote Methode schlug fehl "+ e);
      e.printStackTrace();
      System.exit(4);
      } catch( Exception e ) {
            System.out.println("[Client]Aufruf der remote Methode schlug total fehl ");
            System.out.println("[Client]Exception "+e);
            e.printStackTrace( );
            System.exit(6);
        }
  }
}
